/*
# positions
#  main=(100,100)
*/
types
  States = {opening, closing, open, closed}

interactor main
 attributes
  [vis] status: States
  vSensorSt: boolean
 actions
  # Remote control button
  [vis] rcButton
  # Gate open sensor
  oSensor
  # Gate closed sensor
  cSensor
  # veicule present sensor actions
  vSensorOn
  vSensorOff
 axioms
  [] status = closed & !vSensorSt
  
  status = closed -> [rcButton] (status' = opening)
  status = opening -> [rcButton] (!vSensorSt -> status' = closing) & (vSensorSt -> keep(status))
  status = closing -> [rcButton] (status' = opening)
  status = open -> [rcButton] (!vSensorSt -> status' = closing) & (vSensorSt -> keep(status))

  per(cSensor) -> status = closing
  [cSensor] (status' = closed)

  per(oSensor) -> status = opening
  [oSensor] (status' = open)

  [rcButton|oSensor|cSensor] keep(vSensorSt)


  [vSensorOn] vSensorSt'
  status=closing -> [vSensorOn] status'=opening
  status!=closing -> [vSensorOn] keep(status)
  [vSensorOff] !vSensorSt' & keep(status)
  

 
 
 
 test
  AG!(status=closing & vSensorSt)
 test
  AG!(oSensor & status=open)
 test
  AG(status=opening -> AF(status=open | rcButton))
 test
  AG!(vSensorSt & status=closing)
 test
  AG(status=open -> AX(rcButton -> !(status=open)))
 test
  AG(status=closed -> AX(rcButton -> !(status=closed)))
 test
  AG(status=opening -> AX(rcButton -> !(status=opening)))
 test
  AG(status=closing -> AX(rcButton -> !(status=closing)))
